//     _WXJS.js
//     (c) 2010-2012 Thomas Fuchs
//     _WXJS.js may be freely distributed under the MIT license.
(function () {
  /* ========== REAL WXJS START ========== */
  window.__wxjs_environment = 'miniprogram';

  var _MESSAGE_TYPE = '__msg_type',
    _callback_map = {},
    _callback_count = 1000,
    _CALLBACK_ID = '__callback_id';

  var __wx = window.__wx;
  delete window.__wx;

  function _sendMessage(msg) {
    var msgArray = []; msgArray.push(msg);
    var msgArrayString = JSON.stringify(msgArray);
    __wx._sendMessage(msgArrayString);
  };

  function _handleMessageFromWeixin(message) {
    var msgWrap= message;

    switch (msgWrap[_MESSAGE_TYPE]) {
      case 'callback':
        {
          if (typeof msgWrap[_CALLBACK_ID] === 'string' && typeof _callback_map[msgWrap[_CALLBACK_ID]] === 'function') {
            var ret = _callback_map[msgWrap[_CALLBACK_ID]](msgWrap['__params']);
            delete _callback_map[msgWrap[_CALLBACK_ID]]; // can only call once
            return JSON.stringify(ret);
          }
        }
        break;
    }
  };

  function _call(func, params, callback) {
    if (!func || typeof func !== 'string') {
      return;
    };
    if (typeof params !== 'object') {
      params = {};
    };

    var callbackID = (_callback_count++).toString();

    if (typeof callback === 'function') {
      _callback_map[callbackID] = callback;
    };

    var msgObj = {
      'func': func,
      'params': params
    };
    msgObj[_MESSAGE_TYPE] = 'call';
    msgObj[_CALLBACK_ID] = callbackID;

    try {
      _sendMessage(JSON.stringify(msgObj));
    } catch (e) {
      console.log("_call error", e);
    }
  }

  var __WeixinJSBridge = {
    // public
    invoke: _call,
    call: _call
  };

  try {
    Object.defineProperty(__WeixinJSBridge, '_handleMessageFromWeixin', {
      value: _handleMessageFromWeixin,
      writable: false,
      configurable: false
    });
  } catch (e) {
    return
  }

  try {
    Object.defineProperty(window, 'WeixinJSBridge', {
      value: __WeixinJSBridge,
      writable: false,
      configurable: false
    });
  } catch (e) {
    return; // 如果页面已经存在 WeixinJSBridge，是恶意页面，就直接 return
  }

  // bridge ready
  var readyEvent = new Event('WeixinJSBridgeReady');
  document.dispatchEvent(readyEvent);

})();